#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <ctime>
#include "IntBinaryTree.h"
using namespace std;

void printMenu(string & response) {
	
	cout << "Test Binary Search Tree" << endl<< endl;
	cout << "(i)nsert\n";
	cout << "(s)each\n";
	cout << "(r)emove\n";
	cout << "i(n)order display\n";
	cout << "(p)reorder display\n";
	cout << "p(o)storder display\n";
	cout << "si(z)e\n";
	cout << "(h)eight\n";
	cout << "(c)lear\n";
	cout << "(q)uit\n";
	cout << "\nWhat would you like to do? ";
	cin >> response;

} // end printMenu

int main() {
	IntBinaryTree myTree;
	string command;
	vector<int> myVector;
	vector<int> myVectorCopy;
	vector<int>::iterator left, right;
	int value;
	unsigned startTime, endTime;
	int count, numberOfElements, currentHeight, maxHeight;

	while (true) {
		printMenu(command);
		if (command == "z" || command == "Z") {
			cout << "tree size " << myTree.size() << endl;
		} else if (command == "i" || command == "I") {
			cout << "Enter the value to insert: ";
			cin >> value;
			myTree.insertNode(value);
			myTree.displayInOrder();
		} else if (command == "s" || command == "S") {
			cout << "Enter the value to search for: ";
			cin >> value;

			if (myTree.searchNode(value)) {
				cout << "The search value " << value << " was FOUND!" << endl;
			} else {
				cout << "The search value " << value << " was NOT FOUND!" << endl;
			} // end if
		} else if (command == "r" || command == "R") {
			cout << "Enter the value to remove: ";
			cin >> value;
			myTree.remove(value);
//			myTree.remove2(value);
			cout << "The tree after removing the value " << value << " is:" << endl;			
			myTree.displayInOrder();
		} else if (command == "p" || command == "P") {
			cout << "The preorder tree traversal:" << endl;
			myTree.displayPreOrder();
		} else if (command == "c" || command == "C") {
			myTree.clear();
			cout << "The tree was cleared and now has " << myTree.size() << " elements." << endl;
		} else if (command == "h" || command == "H") {
			cout << "The tree height is " << myTree.height() << "." << endl;
		} else if (command == "o" || command == "O") {
			cout << "The postorder tree traversal:" << endl;
			myTree.displayPostOrder();
		} else if (command == "n" || command == "N") {
			cout << "The inorder tree traversal:" << endl;
			myTree.displayInOrder();
		} else if (command == "q" || command == "Q") {
			break;
		} // end if

		cout << "\n===================================================" << endl;
	} // end while


	//cout << "Enter the number of elements to use to track max. height during removes (50,000?): ";
	//cin >> numberOfElements;

	//// Fill myVector with values 0 to numberOfElements
	//for (count = 0; count < numberOfElements; count++) {
	//	myVector.push_back(count);
	//} // end for

	//// Randomize the elements in myVector
	//random_shuffle ( myVector.begin(), myVector.end() );

	//// Make a copy of myVector in myVectorCopy
	//for (count = 0; count < numberOfElements; count++) {
	//	myVectorCopy.push_back(myVector[count]);
	//} // end for

	//// Reshuffle myVector
	//random_shuffle ( myVector.begin(), myVector.end() );

	//// Add randomize elements from myVector into myTree
	//myTree.clear();
	//for (count = 0; count < numberOfElements; count++) {
	//	myTree.insertNode(myVector[count]);
	//} // end for

	//maxHeight = myTree.height();
	//cout << "After filling the tree, the tree height is " << maxHeight << "." << endl;

	//// Use remove to delete elements from myTree in random order to track the max. height of the tree
	//for (count = 0; count < numberOfElements; count++) {
	//	if (myTree.searchNode(myVectorCopy[count])) {
	//		myTree.remove(myVectorCopy[count]);
	//		currentHeight = myTree.height();
	//		if (currentHeight > maxHeight) {
	//			maxHeight = currentHeight;
	//		} // end if
	//	} else {
	//		cout << "Trying to remove non-existant value" << endl;
	//	} // end if
	//} // end for

	//cout << "During the remove operations, the maximum tree height was " << maxHeight << "." << endl;


	//cout << "\n=================================================\n\n";

	//// Add randomize elements from myVector into myTree
	//myTree.clear();
	//for (count = 0; count < numberOfElements; count++) {
	//	myTree.insertNode(myVector[count]);
	//} // end for

	//maxHeight = myTree.height();
	//cout << "After filling the tree, the tree height is " << maxHeight << "." << endl;

	//// Use remove2 to delete elements from myTree in random order to track the max. height of the tree
	//for (count = 0; count < numberOfElements; count++) {
	//	if (myTree.searchNode(myVectorCopy[count])) {
	//		myTree.remove2(myVectorCopy[count]);
	//		currentHeight = myTree.height();
	//		if (currentHeight > maxHeight) {
	//			maxHeight = currentHeight;
	//		} // end if
	//	} else {
	//		cout << "Trying to remove non-existant value" << endl;
	//	} // end if
	//} // end for

	//cout << "During the remove2 operations, the maximum tree height was " << maxHeight << "." << endl;


	//cout << "\n=================================================\n\n";

	//cout << "Enter the number of elements to use to time all the removes (200,000?): ";
	//cin >> numberOfElements;

	//myVector.clear();
	//myVectorCopy.clear();
	//// Fill myVector with values 0 to numberOfElements
	//for (count = 0; count < numberOfElements; count++) {
	//	myVector.push_back(count);
	//} // end for

	//// Randomize the elements in myVector
	//random_shuffle ( myVector.begin(), myVector.end() );

	//// Make a copy of myVector in myVectorCopy
	//for (count = 0; count < numberOfElements; count++) {
	//	myVectorCopy.push_back(myVector[count]);
	//} // end for

	//// Reshuffle myVector
	//random_shuffle ( myVector.begin(), myVector.end() );

	//// Add randomize elements from myVector into myTree
	//myTree.clear();
	//startTime = static_cast<unsigned>(time(0));
	//for (count = 0; count < numberOfElements; count++) {
	//	myTree.insertNode(myVector[count]);
	//} // end for
	//endTime = static_cast<unsigned>(time(0));
	//cout << "Tree fill time of " << numberOfElements << " elements using insert took " 
	//	<< endTime - startTime << " seconds." << endl;	

	//maxHeight = myTree.height();
	//cout << "After filling the tree, the tree height is " << maxHeight << "." << endl;

	//startTime = static_cast<unsigned>(time(0));
	//for (count = 0; count < numberOfElements; count++) {
	//	if (myTree.searchNode(myVectorCopy[count])) {
	//		myTree.remove(myVectorCopy[count]);
	//	} else {
	//		cout << "Trying to remove non-existant value" << endl;
	//	} // end if
	//} // end for
	//endTime = static_cast<unsigned>(time(0));
	//cout << "Tree remove time of " << numberOfElements << " random elements took " 
	//	<< endTime - startTime << " seconds." << endl;		


	//cout << "\n=================================================\n\n";

	//// Add randomize elements from myVector into myTree
	//myTree.clear();
	//startTime = static_cast<unsigned>(time(0));
	//for (count = 0; count < numberOfElements; count++) {
	//	myTree.insertNode(myVector[count]);
	//} // end for
	//endTime = static_cast<unsigned>(time(0));
	//cout << "Tree fill time of " << numberOfElements << " elements using insert took " 
	//	<< endTime - startTime << " seconds." << endl;	

	//maxHeight = myTree.height();
	//cout << "After filling the tree, the tree height is " << maxHeight << "." << endl;

	//startTime = static_cast<unsigned>(time(0));
	//for (count = 0; count < numberOfElements; count++) {
	//	if (myTree.searchNode(myVectorCopy[count])) {
	//		myTree.remove2(myVectorCopy[count]);
	//	} else {
	//		cout << "Trying to remove2 non-existant value" << endl;
	//	} // end if
	//} // end for
	//endTime = static_cast<unsigned>(time(0));
	//cout << "Tree remove2 time of " << numberOfElements << " random elements took " 
	//	<< endTime - startTime << " seconds." << endl;		


	char dummy[50];
	cin.getline(dummy, 50);
	cout << "Hit any key to quit: ";
	cin.get();

} // end main